/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.bills.controller;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springblade.common.aop.core.TenantAop;
import org.springblade.common.constant.Salesman;
import org.springblade.common.utils.ExcelWriteUtil;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.ldt.bills.entity.FrozenRec;
import org.springblade.ldt.bills.service.IFrozenRecService;
import org.springblade.ldt.bills.vo.FrozenRecVO;
import org.springblade.ldt.bills.wrapper.FrozenRecWrapper;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.Date;
import java.util.Map;

/**
 * 控制器
 *
 * @author BladeX
 * @since 2021-10-30
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("ldt_bills/frozenrec")
@Api(value = "", tags = "接口")
public class FrozenRecController extends BladeController {

	private final IFrozenRecService frozenRecService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入frozenRec")
	public R<FrozenRecVO> detail(FrozenRec frozenRec) {
		FrozenRec detail = frozenRecService.getOne(Condition.getQueryWrapper(frozenRec));
		return R.data(FrozenRecWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
//	@GetMapping("/list")
//	@ApiOperationSupport(order = 2)
//	@ApiOperation(value = "分页", notes = "传入frozenRec")
//	public R<IPage<FrozenRecVO>> list(FrozenRec frozenRec, Query query) {
//		IPage<FrozenRec> pages = frozenRecService.page(Condition.getPage(query), Condition.getQueryWrapper(frozenRec));
//		return R.data(FrozenRecWrapper.build().pageVO(pages));
//	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入frozenRec")
	public R<IPage<FrozenRecVO>> page(FrozenRecVO frozenRec, Query query) {
		IPage<FrozenRecVO> pages = frozenRecService.selectFrozenRecPage(Condition.getPage(query), frozenRec);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入frozenRec")
	public R save(@Valid @RequestBody FrozenRec frozenRec) {
		return R.status(frozenRecService.save(frozenRec));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入frozenRec")
	public R update(@Valid @RequestBody FrozenRec frozenRec) {
		return R.status(frozenRecService.updateById(frozenRec));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入frozenRec")
	public R submit(@Valid @RequestBody FrozenRec frozenRec) {
		return R.status(frozenRecService.saveOrUpdate(frozenRec));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(frozenRecService.deleteLogic(Func.toLongList(ids)));
	}

	/**
	 * 分页 冻结记录
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入frozenRec")
	public R<IPage<FrozenRecVO>> list(FrozenRec frozenRec, Query query, Date createTimeStart, Date createTimeEnd, String key) {
		QueryWrapper<FrozenRec> queryWrapper = Condition.getQueryWrapper(frozenRec);
		//添加创建时间条件
		if (createTimeStart != null && createTimeEnd != null) {
			queryWrapper.lambda().between(FrozenRec::getCreateTime, createTimeStart, createTimeEnd);
		}
		//添加关键字key查询条件
		if (StringUtils.isNotBlank(key)) {
			queryWrapper.lambda().and(wq -> {
				wq.eq(FrozenRec::getId, key);
			});
		}
		//循环查询
		return R.data(FrozenRecWrapper.build().pageVO(frozenRecService.page(Condition.getPage(query), queryWrapper)));
	}

	/**
	 * 生成列表
	 */
	@PostMapping("/generateList")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "生成列表", notes = "传入frozenRec")
	@TenantAop(salesman = Salesman.roleName)
	public void generateList(FrozenRec frozenRec, Query query, Date createTimeStart, Date createTimeEnd,
							 String key,
							 @RequestParam String keyValue,
							 HttpServletResponse response) {
		try {
			R<IPage<FrozenRecVO>> page = this.list(frozenRec, query, createTimeStart, createTimeEnd, key);
			//判断是否为空
			if (ObjectUtils.isNotEmpty(page) && ObjectUtils.isNotEmpty(page.getData()) && ObjectUtils.isNotEmpty(page.getData().getRecords())) {
				//键值对
				Map<String, String> titleMap = JSONObject.parseObject(keyValue, Map.class);
				if (ObjectUtils.isNotEmpty(titleMap)) {
					//写入到Excel
					ExcelWriteUtil.writeToResponse(response, DateUtil.now(), "冻结记录表", titleMap, page.getData().getRecords(), FrozenRecVO.class);
					return;
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage());
		}
	}


}
